BIND(2)

NAME
bind - bind a name to a socket

SYNOPSIS
#include <sys/types.h>
#include <sys/socket.h>

bind(s, name, namelen)
int s;
struct sockaddr *name;
int namelen;

DESCRIPTION
Bind assigns a name to an unnamed socket. When a socket is created with socket(2) it exists in a name space (address family) but has no name assigned. Bind requests the name, be assigned to the socket.

NOTES
Binding a name in the UNIX domain creates a socket in the file system which must be deleted by the caller when it is no longer needed (using unlink(2)). The file created is a side-effect of the current implementation, and will not be created in future versions of the UNIX ipc domain.

The rules used in name binding vary between communication domains. Consult the manual entries in section 4 for detailed information.

RETURN VALUE
If the bind is successful, a 0 value is returned. A return value of -1 indicates an error, which is further specified in the global errno.

ERRORS
The bind call will fail if:

[EBADF]
    S is not a valid descriptor.

[ENOTSOCK]
    S is not a socket.

[EADDRNOTAVAIL]
    The specified address is not available from the local machine.

[EADDRINUSE]
    The specified address is already in use.

[EINVAL]
    The socket is already bound to an address.

[EACCES]
    The requested address is protected, and the current user has inadequate permission to access it.

[EFAULT]
    The name parameter is not in a valid part of the user address space.

SEE ALSO
connect(2), listen(2), socket(2), getsockname(2)